"""
Calculatrice basique Tkinter
Date : 2020.06.04
Author : Stéphane Pasquet
Site : https://www.mathweb.fr
"""
from tkinter import Tk, Entry, Button, StringVar

class Calculator:
    def __init__(self, master):
        master.title('Calculatrice basique')
        master.geometry('500x260')
        master.config(bg='#c0c0c0')
        master.resizable(False, False)
               
        self.equation = StringVar()
        self.entry_value = ''
        Entry(width = 28, bg = 'white', font = ('Times', 16), textvariable = self.equation).place(x=20,y=10)

        Button(width=5, bg = 'grey' , text = '(', relief ='raised', command=lambda:self.show('(')).place(x=10,y=50)
        Button(width=5, bg = 'grey' , text = ')', relief ='raised', command=lambda:self.show(')')).place(x=100, y=50)
        Button(width=5, bg = 'grey' , text = '%', relief ='raised', command=lambda:self.show('%')).place(x=190, y=50)
        Button(width=5, bg = 'grey' , text = '1', relief ='raised', command=lambda:self.show(1)).place(x=10,y=90)
        Button(width=5, bg = 'grey' , text = '2', relief ='raised', command=lambda:self.show(2)).place(x=100,y=90)
        Button(width=5, bg = 'grey' , text = '3', relief ='raised', command=lambda:self.show(3)).place(x=190,y=90)
        Button(width=5, bg = 'grey' , text = '4', relief ='raised', command=lambda:self.show(4)).place(x=10,y=130)
        Button(width=5, bg = 'grey' , text = '5', relief ='raised', command=lambda:self.show(5)).place(x=100,y=130)
        Button(width=5, bg = 'grey' , text = '6', relief ='raised', command=lambda:self.show(6)).place(x=190,y=130)
        Button(width=5, bg = 'grey' , text = '7', relief ='raised', command=lambda:self.show(7)).place(x=10,y=170)
        Button(width=5, bg = 'grey' , text = '8', relief ='raised', command=lambda:self.show(8)).place(x=190,y=170)
        Button(width=5, bg = 'grey' , text = '9', relief ='raised', command=lambda:self.show(9)).place(x=100,y=170)
        Button(width=5, bg = 'grey' , text = '0', relief ='raised', command=lambda:self.show(0)).place(x=10,y=210)
        Button(width=5, bg = 'grey' , text = '.', relief ='raised', command=lambda:self.show('.')).place(x=100,y=210)
        Button(width=5, bg = 'purple' , fg = 'white' , text = '+', relief ='raised', command=lambda:self.show('+')).place(x=280,y=90)
        Button(width=5, bg = 'purple' , fg = 'white' , text = '-', relief ='raised', command=lambda:self.show('-')).place(x=280,y=130)
        Button(width=5, bg = 'purple' , fg = 'white' , text = '/', relief ='raised', command=lambda:self.show('/')).place(x=280,y=170)
        Button(width=5, bg = 'purple' , fg = 'white' , text = 'x', relief ='raised', command=lambda:self.show('*')).place(x=280,y=210)
        Button(width=5, text = '=', bg='green', relief ='raised', command=self.solve).place(x=190, y=210)
        Button(width=5, bg = 'blue' , fg = 'white' , text = 'AC', relief ='raised', command=self.clear).place(x=280,y=50)
        
        Button(width=20,relief='flat',bg='#c0c0c0',text='[Esc] : AC' , command=lambda:self.delete()).place(x=350,y=50)
        Button(width=20,relief='flat',bg='#c0c0c0',text='[Entrée] : "="').place(x=350,y=90)
        Button(width=20,relief='flat',bg='#c0c0c0',text='% : reste div. euclidienne').place(x=350,y=130)
        Button(width=20,relief='flat',bg='#c0c0c0',text='(Exemple: 5 % 2 = 1)').place(x=350,y=150)

    def show(self, value):
        self.entry_value +=str(value)
        self.equation.set(self.entry_value)
      
    def clear(self):
        self.entry_value = ''
        self.equation.set(self.entry_value)
    
    def solve(self):
        result = eval(self.entry_value)
        self.equation.set(result)
        
    def delete(self):
        self.entry_value = self.entry_value[:-1]
        self.equation.set(self.entry_value)
   
root = Tk()
calculator = Calculator(root)
root.bind('<Return>', lambda event: calculator.solve())
root.bind('<Escape>', lambda event: calculator.clear())
root.bind('<BackSpace>', lambda event: calculator.delete())
root.bind('<Key>', lambda event: calculator.show(event.char) )

root.mainloop()